package ru.ulstu.extractor.ts.model;

import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;
import ru.ulstu.extractor.core.BaseEntity;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import java.util.ArrayList;
import java.util.List;

@Entity
public class TimeSeries extends BaseEntity {
    private String name;
    @OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
    @JoinColumn(name = "time_series_id")
    @Fetch(FetchMode.SUBSELECT)
    private List<TimeSeriesValue> values = new ArrayList<>();

    @Enumerated(EnumType.STRING)
    private TimeSeriesType timeSeriesType;

    public TimeSeries() {
    }

    public TimeSeries(String name) {
        this.name = name;
    }

    public TimeSeries(String name, List<TimeSeriesValue> values) {
        this.name = name;
        this.values = values;
    }

    public TimeSeries(String name, TimeSeriesType timeSeriesType, List<TimeSeriesValue> values) {
        this.name = name;
        this.values = values;
        this.timeSeriesType = timeSeriesType;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<TimeSeriesValue> getValues() {
        return values;
    }

    public void setValues(List<TimeSeriesValue> values) {
        this.values = values;
    }

    public TimeSeriesType getTimeSeriesType() {
        return timeSeriesType;
    }

    public void setTimeSeriesType(TimeSeriesType timeSeriesType) {
        this.timeSeriesType = timeSeriesType;
    }
}
